var scene = new THREE.Scene();
scene.background = new THREE.Color( 0xffffff );
var camera = new THREE.PerspectiveCamera(
  75,
  window.innerWidth / window.innerHeight, 
  0.1, 
  1000
);
camera.position.z = 250;

var renderer = new THREE.WebGLRenderer();
renderer.setPixelRatio( window.devicePixelRatio );
renderer.setClearColor( 0x000000, 0.0 );
renderer.setSize(window.innerWidth, window.innerHeight);
document.body.appendChild(renderer.domElement);

var mesh = teal.dice.create_d20();
mesh.geometry.faces.forEach((face) => console.log(face.normal));
// mesh.castShadow = true;
// mesh.dice_type = "d20"; // we throw things here
// mesh.body = new CANNON.Body({
//   mass: teal.dice.dice_mass["d20"],
//   shape: mesh.geometry.cannon_shape,
// });
// mesh.body.position.set(0,0,0);

//var geo = new THREE.EdgesGeometry( mesh.geometry );
//var mat = new THREE.LineBasicMaterial( { color: 0xff0000, linewidth: 5} );
//var wireframe = new THREE.LineSegments( geo, mat );

var geo = new THREE.WireframeGeometry2(mesh.geometry);
var mat = new THREE.LineMaterial( { color: 0x000000, linewidth: 0.004, dashed: false} );
var wireframe = new THREE.Wireframe( geo, mat );
wireframe.computeLineDistances();
wireframe.scale.set(1.01,1.01,1.01);

//var geo = new THREE.WireframeGeometry2( mesh.geometry );
//var mat = new THREE.LineMaterial( { color: 0xff0000, linewidth: 1} );
//var wireframe = new THREE.Wireframe( geo, mat );
//wireframe.renderOrder = 1; // make sure wireframes are rendered 2nd
mesh.add(wireframe);
scene.add(mesh);
//scene.add(wireframe);

var accumulatedY = 0;
function getTargetEuler(faceIndex) {
  var targetFace = mesh.geometry.faces[faceIndex];

  // Rotate face to z direction
  var q4 = new THREE.Quaternion();
  q4.setFromUnitVectors(targetFace.normal,
    new THREE.Vector3(0,0,1));

  // Rotate first vertex up or something
  var up = mesh.geometry.vertices[targetFace.b].clone();
  up.addScaledVector(mesh.geometry.vertices[targetFace.a], -0.5);
  up.addScaledVector(mesh.geometry.vertices[targetFace.c], -0.5);
  up.applyQuaternion(q4);
  up.normalize();
  var q5 = new THREE.Quaternion();
  q5.setFromUnitVectors(up, new THREE.Vector3(0,1,0));

  q4.premultiply(q5);

  var targetEuler = new THREE.Euler();
  targetEuler.setFromQuaternion(q4);
  // targetEuler.x += Math.floor(Math.random() * 100) * 2 * Math.PI;
  accumulatedY += 20 + Math.floor(Math.random() * 100);
  targetEuler.x += Math.floor(Math.random() * 4) * 2 * Math.PI;
  targetEuler.y += accumulatedY * 2 * Math.PI;

  return targetEuler;
}

var targetEuler;
// = getTargetEuler(Math.floor(Math.random() * 20));

var yt = 100;

mesh.rotation.z = 0.4;
var render = function() {
  requestAnimationFrame(render);

  if (yt < 100 || targetEuler) {
    if (targetEuler) {
      mesh.rotation.x = mesh.rotation.x * 0.95 + targetEuler.x * 0.05;
      mesh.rotation.y = mesh.rotation.y * 0.95 + targetEuler.y * 0.05;
      mesh.rotation.z = mesh.rotation.z * 0.95 + targetEuler.z * 0.05;
    }
    if (yt < 100) {
      yt += 1;
      switch (yt) {
        case -9: revis(1); break;
        case -6: revis(0); break;
        case -3: revis(1); break;
        case  0: revis(2); break;
        case  3: revis(3); break;
        case  6: revis(4); break;
        case  9: revis(3); break;
        case 12: revis(2); break;
      }
      if (yt == 0) {
        targetEuler = getTargetEuler(Math.floor(Math.random() * 20));
      }
    }
    if (yt >= 0) {
      mesh.position.y = yt * (100 - yt) / 20;
    } else {
      mesh.position.y = yt * (10 + yt) / 5;
    }
  } else {
    mesh.rotation.y += 0.06;
  }

  // fixed the rotation to reference your mesh

  //m4.lookAt(
  //    new THREE.Vector3(0,0,0),
  //    mesh.geometry.faces[3].normal,
  //    new THREE.Vector3(0,0,0));
  //m4.getInverse(m4);
  //mesh.rotation.setFromRotationMatrix(m4);
  //mesh.rotation.x += .01;
  //mesh.rotation.y += .01;

  renderer.render(scene, camera);
};

var loader = new THREE.SVGLoader();
var spriteFilenames = [
'0.svg',
'1.svg',
'2.svg',
'3.svg',
'4.svg',
];
var spriteGroups = {};
spriteFilenames.forEach((filename, fi) => {
  loader.load( filename, function ( paths ) {
    var group = new THREE.Group();
    group.scale.multiplyScalar( 0.7 );
    group.position.x = - 310;
    group.position.y = 235;
    group.position.z = 50;
    group.scale.y *= - 1;
    for ( var i = 0; i < paths.length; i ++ ) {
      var path = paths[ i ];
      console.log(path.color);
      var material = new THREE.MeshBasicMaterial( {
        color: path.color,
        side: THREE.DoubleSide,
        depthWrite: false
      } );
      var shapes = path.toShapes( true );
      for ( var j = 0; j < shapes.length; j ++ ) {
        var shape = shapes[ j ];
        var geometry = new THREE.ShapeBufferGeometry( shape );
        var mesh = new THREE.Mesh( geometry, material );
        group.add( mesh );
      }
    }
    scene.add( group );
    group.visible = fi == 2;
    spriteGroups[filename] = group;
  } );
});
var revis = (i) => {
  spriteFilenames.forEach((filename, j) => {
    var group = spriteGroups[filename];
    if (group) {
      group.visible = i == j;
    }
  });
};
// requestAnimationFrame(() => revis(2));
var actThrow = () => {
  if (yt >= 100) {
    yt = -10;
  }
};
// requestAnimationFrame(revis);

render();

setTimeout(actThrow, 2000);

renderer.domElement.addEventListener("click", actThrow);

// setTimeout(() => actThrow(), 1000);
